#!/usr/bin/perl

######################################################
#        getIP, Perl Version fr Linux / Unix        #
#                                                    #
#               (C) 2000 by Jens Eich                #
#            Version 1.01 vom 02.02.2001             #
#                                                    #
#                 EveryConsult  GbR                  #
#            Jens Eich und Tobias Massin             #
#                 Hospitalstrae 30                  #
#              D-41751  Viersen-Dlken               #
#                                                    #
#             Telefon  +49 2162 9702030              #
#             Telefax  +49 2162 9702031              #
#                                                    #
#             http://www.everyconsult.de             #
#                eich@everyconsult.de                #
######################################################
# Dieses Programm ist dazu da, regelmig per        #
# Cronjob aufgerufen zu werden, die aktuelle IP des  #
# Internetzugangs zu holen und auf nderungen zu     #
# berprfen. Bei nderungen erfolgt ein POST-Aufruf #
# eines speziellen CGIs auf dem Nameserver, dadurch  #
# wird die Absender-IP automatisch nach sptestens   #
# 5 Minuten als neue IP des Servers bernommen.      #
######################################################
# Standardmig schreibt das Programm alle Fehler    #
# sowie alle nderungen in eine Logdatei und auf den #
# Standard-Output. Bei Aufruf mit dem Parameter      #
# modus=laut werden umfangreichere Logs geschrieben, #
# dieses sollte jedoch nur zu Testzwecken und bei    #
# der Fehlersuche verwendet werden. Bei Aufruf mit   #
# dem Parameter modus=leise schreibt das Programm    #
# berhaupt keine Ausgaben mehr an die Standard-     #
# Ausgabe. Wenn auch keine Logdatei mehr geschrieben #
# werden soll, kann einfach der Name der Logdatei    #
# auf "" gesetzt werden.                             #
######################################################
# Fr die vom Programm gepflegten Dateien zum        #
# Speichern der letzten IP sowie der Logdatei ist es #
# ntig, dem Programm Schreibrechte in dem           #
# entsprechenden Verzeichnis zu geben!               #
######################################################
# Das Programm hat eine spezielle Funktion, mit der  #
# es sich beim Nameserver abmelden kann, bevor der   #
# Server z.B. wegen Wartungsarbeiten offline geht.   #
# Dazu mu in der Kommandozeile nur der Parameter    #
# setip=offline bergeben werden. Ein solcher Aufruf #
# knnte z.B. in das entsprechende ppp-down Skript   #
# integriert werden.                                 #
######################################################



##### Ab hier folgen die ganzen anzupassenden Variablen #####

##### Zu allererst sollte in der obersten Zeile unbedingt der
##### Pfad zu Perl angepat werden. In der Regel kann die Vorgabe
##### bernommen werden.

##### Name des Servers, sowie Pfad und Name des Programms
##### wohin die IP-Updates bertragen werden. Diese Variable
##### sollte normalerweise nicht gendert werden, sonst kann
##### das Programm nicht korrekt funktionieren. Nach Rcksprache
##### mit uns kann jedoch eine nderung erfordetlich werden.
$dynipserv = "http://dynip.domaenenserver2.de/cgi-bin/setip.cgi";

##### Zugangsdaten zum DynIP-Nameserver eintragen
##### Der Benutzername, z.b. in der Form "r10k1000u1"
$dynipuser = "";
##### Das Benutzerpawort
$dynippass = "";
##### Die IP-Gruppe, z.B. der Form "r10k1000u1"
$dynipgrup = "";

##### Lokale IP-Adressen oder deren Anfangsteile, die ignoriert werden sollen
##### Vorgegeben sind alle privaten Adressen nach RFC1918
##### Falls weitere interne eMail-Adressen verwendet werden,
##### diese bitte ebenfalls in die Liste eintragen!
@lokalips = ("192.168.", "172.16.", "172.17.", "172.18.", "172.19.", "172.20.", "172.21.", "172.22.", "172.23.", "172.24.", "172.25.", "172.26.", "172.27.", "172.28.", "172.29.", "172.30.", "172.31.", "10.", "127.0.0.");

##### Pfad und Name des Programms zur Ermittlung der IP, bei Suse Linux z.B. /sbin/ifconfig
$dynipprog = "/sbin/ifconfig";

##### Name des Gertes, ber das der Internetzugang aufgebaut wird
##### z.B. ippp0 oder ppp0 oder pppoe oder eth1 oder hnliche
$dynipdevi = "ippp0";

##### Zum Heraussuchen der IP verwendete Texte 
##### Text der direkt vor der IP steht, bei Suse Linux z.B. "inet addr:", bei FreeBSD z.B. "inet"
$dynipvtxt = "inet addr:";
##### Text der direkt hinter der IP steht, bei Suse Linux z.B. "P-t-P:", bei FreeBSD z.B. "netmask"
$dyniphtxt = "P-t-P:";

##### Pfad und Name der Datei zur Speicherung der letzten bekannten IP
$dynipfile = "/home/getip/letzteip.dat";

##### Pfad und Name der Datei zur Speicherung der nderungen an der IP
$dyniplogs = "/home/getip/getip.log";

##### Und ab hier blo nichts mehr ndern #####



##### Diese Module werden unbedingt bentigt, gegebenenfalls von http://cpan.perl.org besorgen
require HTTP::Request;
require LWP::UserAgent;

##### Einlesen der an das CGI bermittelten Daten
if ($ARGV[0] ne "")
  {
    for ($i=0; $i<=@ARGV; $i++)
      {
        $temp = $temp . $ARGV[$i] . "&";
      }
    $temp =~ s/\&$//g;
  }
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
  read(STDIN,$temp,$ENV{'CONTENT_LENGTH'});
}
else {
  $temp=$ENV{'QUERY_STRING'};
}

##### Trennen und Entpacken der bermittelten Daten
@parameter = split(/&/,$temp);
foreach $zeile(@parameter)
  {
    ($name,$wert) = split(/=/,$zeile,2);
    $wert =~ tr/+/ /;
    $wert =~ s/%(..)/pack("c",hex($1))/ge;
    $form{$name} = $wert;
  }

if ($form{'setip'} ne "offline")
  {
    ##### Die IP soll voll gesetzt werden

    ##### Einlesen der IP-Konfiguration
    @ergebnis = split(/\n/, `$dynipprog`);

    ##### Heraussuchen aller Zeilen des passenden Gertes
    $modus = 0;
    $geraet = "";
    foreach $zeile (@ergebnis)
      {
        if ($zeile !~ /^ /)
          {
            if ($zeile =~ /^$dynipdevi/)
              {
                $geraet = $geraet . $zeile;
                $modus = 1;
              }
            elsif ($modus == 1)
              {
                $modus = 0;
              }
          }
        elsif ($modus == 1)
          {
            $geraet = $geraet . $zeile;
          }
      }

    if ($geraet ne "")
      {
        ##### Durchsuchen der Zeilen nach dem Anfangstext, der IP und dem Endtext
        if ($geraet =~ /$dynipvtxt *(\d+\.\d+\.\d+\.\d+) *$dyniphtxt/)
          {
            ##### Es wurde eine IP gefunden, also mit den lokalen IPs vergleichen
            $online = "JA";
            $aktip = $1;
            $aktip =~ s/\s//g;
            foreach $lokal (@lokalips)
              {
                if ($aktip =~ /^$lokal/)
                  {
                    $online = "NEIN";
                  }
              }
            if ($online eq "JA")
              {
                ##### Die gefundene IP scheint eine Online-IP zu sein
                $modus = 0;
                $letip = "";
                if (-e $dynipfile)
                  {
                    ##### Eventuelle letzte IP zum Vergleich laden
                    open (dyf, "<$dynipfile");
                      flock dyf, 2;
                      read dyf, $letip, 50;
                    close(dyf);
                  }
                if ($letip ne $aktip)
                  {
                    ##### Die IP hat sich verndert und mu an den Nameserver bertragen werden
                    $modus = 1;
                    $abfrage1 = $dynipserv;
                    $abfrage2 = "jename=" . $dynipuser . "&jepasswort=" . $dynippass . "&jeipgruppe=" . $dynipgrup;
                    $ua = LWP::UserAgent->new;
                    $ua->agent("getip.pl V0.1 (C) 2000 by Jens Eich");
                    $request = HTTP::Request->new('POST' => $abfrage1);
                    $request->content_type('application/x-www-form-urlencoded');
                    $request->content($abfrage2);
                    $rueck = $ua->request($request);
                    if ($rueck->is_success)
                      {
                        $fehler = $rueck->content();
                        ##### Hat der Server bei der bertragung die korrekte Antwort geliefert?
                        if (($fehler =~ /wird beim nchsten Reload/) || ($fehler =~ /ist unverndert auf/))
                          {
                            $modus = 2;
                          }
                      }
                  }
                ##### Die passende Ausgabe erzeugen
                if ($modus == 2)
                  {
                    open (dyf, ">$dynipfile");
                      flock dyf, 2;
                      print dyf $aktip;
                    close(dyf);
                    &ausgabe("Online: Die IP hat sich von " . $letip . " auf " . $aktip . " gendert und wurde neu eingetragen!");
                    if ($form{'modus'} =~ /laut/)
                      {
                        &ausgabe($fehler);
                      }
                  }
                elsif ($modus == 1)
                  {
                    &ausgabe("Fehler: Die IP hat sich von " . $letip . " auf " . $aktip . " gendert, konnte aber nicht neu eingetragen werden!");
                    if ($form{'modus'} =~ /laut/)
                      {
                        &ausgabe($fehler);
                      }
                  }
                elsif (($modus == 0) && ($form{'modus'} =~ /laut/))
                  {
                    &ausgabe("Online: Die IP ist unverndert auf " . $aktip . " geblieben!");
                  }
              }
            else
              {
                ##### Die gefundene IP-Adresse pate auf eine der als lokal angegeben IPs
                &ausgabe("Offline: Die gefundene IP " . $aktip . " ist eine lokal verwendete!");
              }
          }
        else
          {
            ##### Es konnte keine IP-Adresse anhand des Anfangs- und Endtextes ermittelt werden
            &ausgabe("Fehler: Konnte zwischen " . $dynipvtxt . " und " . $dyniphtxt . " keine IP finden!");
          }
      }
    else
      {
        ##### Das Gert konnte nicht gefunden werden, also Fehlermeldung ausgeben
        &ausgabe("Fehler: Kann das Gert " . $dynipdevi . " nicht finden!");
      }
  }
else
  {
    ##### Die IP soll gelscht werden, weil der PC offline geht, also an den Nameserver bertragen
    $modus = 1;
    $aktip = "0.0.0.0";
    $abfrage1 = $dynipserv;
    $abfrage2 = "jename=" . $dynipuser . "&jepasswort=" . $dynippass . "&jeipgruppe=" . $dynipgrup . "&setip=offline";
    $ua = LWP::UserAgent->new;
    $ua->agent("getip.pl V0.1 (C) 2000 by Jens Eich");
    $request = HTTP::Request->new('POST' => $abfrage1);
    $request->content_type('application/x-www-form-urlencoded');
    $request->content($abfrage2);
    $rueck = $ua->request($request);
    if ($rueck->is_success)
      {
        $fehler = $rueck->content();
        ##### Hat der Server bei der bertragung die korrekte Antwort geliefert?
        if (($fehler =~ /wird beim nchsten Reload/) || ($fehler =~ /ist unverndert auf/))
          {
            $modus = 2;
          }
      }
    if ($modus == 2)
      {
        open (dyf, ">$dynipfile");
          flock dyf, 2;
          print dyf $aktip;
        close(dyf);
        &ausgabe("Offline: Die IP wurde auf Offline gesetzt und neu eingetragen!");
        if ($form{'modus'} =~ /laut/)
          {
            &ausgabe($fehler);
          }
      }
    elsif ($modus == 1)
      {
        &ausgabe("Fehler: Die IP wurde auf Offline gesetzt, konnte aber nicht neu eingetragen werden!");
        if ($form{'modus'} =~ /laut/)
          {
            &ausgabe($fehler);
          }
      }
  }
exit;

##### Hier ist die Routine fr Meldungen des Programms etc.
sub ausgabe
  {
    $meldung = $_[0];
    $meldung = &datumuhr . ": " . $meldung . "\n";
    if ($form{'modus'} !~ /leise/)
      {
        print $meldung;
      } 
    if ($dyniplogs ne "")
      {
        if (-e $dyniplogs)
          {
            open (dyl, ">>$dyniplogs");
              flock dyl, 2;
              print dyl $meldung;
            close(dyl);
          }
        else
          {
            open (dyl, ">$dyniplogs");
              flock dyl, 2;
              print dyl $meldung;
            close(dyl);
          }
      }
  }

##### Hier wird das Datum und die Uhrzeit berechnet
sub datumuhr
  {
    ($sek, $min, $std, $tag, $mon, $jah, $dummy, $dummy, $dummy) = localtime(time);
    $mon++;
    $jah = $jah + 1900;
    $datumuhr = sprintf("%02d", $tag) . "." . sprintf("%02d", $mon) . "." . $jah . " " . sprintf("%02d", $std) . ":" . sprintf("%02d", $min) . ":" . sprintf("%02d", $sek);
    return $datumuhr;
  }
